d("paymentPODView",['ccrz', 'util', 'paymentPODModel'], function(CCRZ, UTIL, PaymentsPODModel){
    return {
        extendPaymentsPODView: function(){
            console.log('window.Label'+JSON.stringify(window.Label));
            /*console.log('window.Label1'+window.Label['B2BCust_PaySaveEnvironment']);
            console.log('window.Label2'+JSON.stringify(window.Label['B2BCust_PaySaveEnvironment']));
            var env = window.Label['B2BCust_PaySaveEnvironment'];*/
            CCRZ.views.PaymentsPODView = CCRZ.CloudCrazeView.extend({ 
                viewName : "PaymentsPODView",
                managedSubView : true,
                //el: 'creditcard',
                /* Template ID referenced here*/ 
                paymentType : '',
                templateDesktop: CCRZ.util.template(CCRZ.uiProperties.paymentPODView.desktop.tmpl),
                templatePhone: CCRZ.util.template(CCRZ.uiProperties.paymentPODView.desktop.tmpl),
                contactMailing : {},
                // templateDesktop : CCRZ.util.template("PaymentCRD-Both"),
                /* Template ID referenced here*/ 
                //templatePhone : CCRZ.util.template("PaymentCRD-Both"), 
                init : function(options){
                    this.selector = options.selector;
                    //this.customStateView = new CCRZ.views.customStateView();
                    CCRZ.pubSub.trigger('action:paymentViewInit', this);        
                    let url=CCRZ.pagevars.currSiteURL;
                    let countryCode=CCRZ.cartCheckoutModel.attributes.billingAddress.countryCode;
                    let _this = this;
                    this.paymentType='Cybersource';
                    /*if(countryCode == 'CA'){
                        this.paymentType='Paysafe'
                    }
                    else if(countryCode == 'US'){
                        this.paymentType='Cybersource'
                        
                    }*/
                    this.selector = options.selector;
                    /* remoting cloudcarze remoting callout _this.model */
                    _this.invokePGInitiation(this.paymentType);
                    
                },
                events: {
                    'change #cardType' : 'handleCartTypeChange'
                },
                postRender : function(){
                    /* get the variable from the model  _this.model.get and pass the function */
                    let _this= this;
                    let respData= this.model.get('data');
                    _this.model.set('submitCounter', 0);
                    _this.model.set('isInit', true);
                    if(this.paymentType == 'Cybersource'){
                        window.setTimeout(function(){
                            //renderMicroFlexForm(respData, _this);
                        }, 500);
                    }
                    changeCountry();
                    $("#makePODPayment").prop("disabled", true);
                    /*else if(this.paymentType=='Paysafe'){
                        //paysafe();
                        B2BpaysafeForm(respData);
                    }*/

                },
                renderDesktop : function(){
                    this.setElement(this.selector);
                    this.data={};
                    let _this = this;
                    this.$el.html(this.templateDesktop(this.data));
                },
                renderPhone : function(){
                    this.setElement(this.selector);
                    this.data={};
                    this.$el.html(this.templatePhone(this.data));
                },
                handleCartTypeChange: function(){
                    // Validate Card
                    let respData= this.model.get('data'), _this = this;
                    let init = _this.model.get('isInit');
                    if(init && this.paymentType == 'Cybersource'){
                        _this.model.set('isInit', false);
                        renderMicroFlexForm(respData, _this);
                        $("#makePODPayment").prop("disabled", false);
                    } else {
                        if(!init){
                            $('input[name="credit-card-number"]').value = '';
                        }
                    }
                },
                invokePGInitiation: function(paymentType){
                    let reqData={paymentType: paymentType,
                        url:CCRZ.pagevars.currSiteURL,
                        countryCode: CCRZ.cartCheckoutModel.attributes.billingAddress.countryCode,
                        cartEnyId:CCRZ.pagevars.currentCartID
                    };
                    let _this = this;            
                    /* cybersource  paysafe */
                    _this.model.fetchPublicKey(JSON.stringify(reqData),function(response, event){
                        if(response == null){
                            console.log('issue with form');                           
                            document.body.scrollTop = 0; // For Safari
                            document.documentElement.scrollTop = 0; 
                            $("#errordiv").css("display", "block");
                            $("#errorMsg").html(CCRZ.pagevars.pageLabels.CybersourceFormError);
                            $("#makePODPayment").prop("disabled", true);
                        }
                        else{
                            if(response.success) {
                            _this.model.set('data',response.data);
                            
                            if(_this.paymentType == 'Cybersource'){
                                _this.render();
                            }
                            /*else if(_this.paymentType=='Paysafe'){
                                B2BpaysafeForm(response.data);
                            }*/

                            //  _this.postRender();
                            } else {                           
                                //alert(response.data); // Seems like there is a problem, Please try again.                          
                                alert('Seems like there is a problem, Please try again');
                            }
                        }
                    });
                    _this.model.getContactmailingAddress(function(response, event){
                        if(response.success){
                            if(response.data){
                                this.contactMailing = response.data;
                                if(!_.isUndefined(this.contactMailing)){
                                    if(!_.isUndefined(this.contactMailing.MailingCountry)){
                                        populateState(this.contactMailing.MailingCountry);
                                    } else {
                                        populateState('US');
                                    }
                                    $('#cardFirstName').val(!_.isUndefined(this.contactMailing.FirstName) ? this.contactMailing.FirstName : "");
                                    $('#cardLastName').val(!_.isUndefined(this.contactMailing.LastName) ? this.contactMailing.LastName : "");
                                    $('#cardStreet').val(!_.isUndefined(this.contactMailing.MailingStreet) ? this.contactMailing.MailingStreet : "");
                                    $('#cardCity').val(!_.isUndefined(this.contactMailing.MailingCity) ? this.contactMailing.MailingCityMailingCity : "");
                                    $('#countryId').val(!_.isUndefined(this.contactMailing.MailingCountry) ? this.contactMailing.MailingCountry : "US");
                                    $('#cardPostalCode').val(!_.isUndefined(this.contactMailing.MailingPostalCode) ? this.contactMailing.MailingPostalCode : "");
                                    $('#stateId').val(!_.isUndefined(this.contactMailing.MailingState) ? this.contactMailing.MailingState : "AL");                  
                                }
                            }
                        }
                        
                    });                    
                },
            });   
            CCRZ.pubSub.trigger('action:paymentViewReady','pod',function(options){
                CCRZ.payment = CCRZ.payment||{views:{}};
                CCRZ.payment.views.pod = new CCRZ.views.PaymentsPODView({
                    /*Logic that associates the Backbone view to its corresponding model.*/
                    model : new PaymentsPODModel(), 
                    selector : ".paymentTypeContainer.pod"
                });
            });
            //need to refresh the component for every 15 min  1000 * 60 * 15
            setInterval(
                function(){ 
                    $.alert({
                        title: window.Label.B2BCust_TooLongWait,
                        content:window.Label.B2BCust_AutoRefreshed,   
                        });
                        reload();
                    },
                60000*5
            );
            function reload(){
                setTimeout(
                    function() {
                        location.reload();
                    },
                    5000
                );
            }    
            function refreshMicroFlexForm(){
                CCRZ.pubSub.trigger('action:paymentViewReady','pod',function(options){
                    CCRZ.payment = CCRZ.payment||{views:{}};
                    CCRZ.payment.views.pod = new CCRZ.views.PaymentsPODView({
                        model : new CCRZ.models.PaymentsPODModel(), 
                        selector : '.paymentTypeContainer.pod'
                        //selector : options.selector
                    });
                });
            }     
            function populateCountry(){
                let countryList =  CCRZ.geoCodes.countryList.toJSON();
                let coutryData = ''; 
                $.each(countryList,function(index,data){
                    if(data.value == 'US'){
                        coutryData +='<option value="'+data.value+'">'+data.label+'</option>';
                    }
                });
                $('#countryId').html(coutryData);
            }
            function populateState(countryCode){
                let stateList = CCRZ.geoCodes.filterStates(countryCode).toJSON();
                    let stateHtml = '';
                    $.each(stateList,function(index,data){
                        stateHtml+='<option value="'+data.value+'">'+data.label+'</option>';
                    });
                $('#stateId').html(stateHtml);
            }
            function changeCountry(){
                $('#countryId').on('change', function() {
                    populateState(this.value);
                });
            }
            function renderMicroFlexForm(resData, _this){
                var isValidate=false;
                var cardError = '';
                var cardType = '';
               
                if(resData!= null){
                    var jwk = JSON.parse(resData).jwk;
                    var cyberSourceform = document.getElementById('cyberSource-form');
                    var cardBox = document.querySelector('input[name="credit-card-number"]');
                    var flexResponse = document.querySelector('#flex-response'); 
                    var expMonth = document.querySelector('#expMonth');
                    var expYear = document.querySelector('#expYear');
                    var cvv=document.querySelector('#cvv');
                    populateCountry();
                    //populateState('US');
                    if(this.contactMailing != undefined){
                        if(this.contactMailing.MailingCountry !== undefined){
                            populateState(this.contactMailing.MailingCountry);
                        } else {
                            populateState('US');
                        }
                        document.getElementById('cardFirstName').value = this.contactMailing.FirstName !== undefined ? this.contactMailing.FirstName : "";
                        document.getElementById('cardLastName').value = this.contactMailing.LastName !== undefined ? this.contactMailing.LastName : ""; 
                        document.getElementById('cardStreet').value =this.contactMailing.MailingStreet !== undefined ? this.contactMailing.MailingStreet : "";
                        document.getElementById('cardCity').value = this.contactMailing.MailingCity !== undefined ? this.contactMailing.MailingCity : ""; 
                        document.getElementById('countryId').value = this.contactMailing.MailingCountry !== undefined ? this.contactMailing.MailingCountry : "US";
                        document.getElementById('cardPostalCode').value = this.contactMailing.MailingPostalCode !== undefined ? this.contactMailing.MailingPostalCode : "";
                        document.getElementById('stateId').value = this.contactMailing.MailingState !== undefined ? this.contactMailing.MailingState : "AL";                    
                    } else {
                        populateState('US');
                    }
                    
                    //document.getElementById('countryId').value = 'US';
                    // Retrieve CyberSource Flex Form Address Fields
                    let B2BContactAddress = {   
                                                ccFirstName:document.getElementById('cardFirstName').value,
                                                ccLastName:document.getElementById('cardLastName').value,
                                                ccStreet:document.getElementById('cardStreet').value,
                                                ccCity:document.getElementById('cardCity').value,
                                                ccState:document.getElementById('stateId').value,
                                                ccPostalCode:document.getElementById('cardPostalCode').value,
                                                ccCountry:document.getElementById('countryId').value
                                            };

                    // SETUP MICROFORM
                    FLEX.microform(
                        {
                            keyId: jwk.kid,
                            keystore:jwk,
                            container: '#cardNumber-container',
                            label: '#cardNumber-label',
                            placeholder: 'Enter Card Number here',                            
                            styles: {
                                'input': {
                                    'font-family': '-apple-system,BlinkMacSystemFont,"Segoe UI",Roboto,"Helvetica Neue",Arial,sans-serif,"Apple Color Emoji","Segoe UI Emoji","Segoe UI Symbol"',
                                    'font-size': '1rem',
                                    'line-height': '1.5',
                                    'color': '#495057',
                                },
                                ':focus': {'color': '#a94442'},
                                ':disabled': {'cursor': 'not-allowed'},
                                'valid': {'color': '#3c763d'},
                                'invalid': {'color': '#a94442'},
                            },
                            encryptionType: window.Label.B2BCust_encryptionType
                        },
                        function (setupError, microformInstance){
                            console.log('setupError '+setupError);                            
                            if (setupError) {
                                // handle error
                                return;
                            }
                            var isCardValid = false;    
                                
                            microformInstance.on('validationChange',function(data){
                                if(data.valid){                                                                      
                                    isCardValid = true
                                }
                                else{
                                    isCardValid = false;
                                }
                            });
                            microformInstance.on('cardTypeChange', function(data) {
                                //ccrz.ccLog.log(LoggingLevel.DEBUG, '$$$$$$$CardData ', data);
                                if(data.card != undefined && data.card.length > 0){
                                    if( data.card[0].brandedName != undefined){
                                        cardType = data.card[0].brandedName;
                                        $("#cvv").attr('maxlength',data.card[0].code.length);
                                        $('[name="credit-card-number"]').attr('maxlength',data.card[0].lengths[0]);
                                    }
                                }
                                if(!_.isUndefined($('input[name="credit-card-number"]').value)){
                                    if($('input[name="credit-card-number"]').value.length > 0){
                                        $('input[name="credit-card-number"]').placeholder = '';
                                    } else {
                                        $('input[name="credit-card-number"]').placeholder = 'Enter Card Number here';
                                    }
                                }
                                //ccrz.ccLog.log(LoggingLevel.DEBUG, '$$$$$$$CardType ', cardtype);
                            });
                            //intercept the form submission and make a tokenize request instead
                            cyberSourceform.addEventListener('submit', function(){
                                UTIL.showLoader();
                                event.preventDefault();
                                let submitCounter = _this.model.get('submitCounter');
                                if(submitCounter <= 1){
                                    _this.model.set('submitCounter', 1);
                                    let isCheck = $('.cc_tc_terms').is(':checked');
                                    if(!isCheck){
                                        CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('INFO', "storedpayment-messagingSection-Info", CCRZ.processPageLabelMap('KFB2B_Checkout_TermsError').toString()));
                                        $('html, body').animate({
                                            'scrollTop' : $(".storedpayment-messagingSection-Info").position().top
                                        });
                                        setTimeout(function(){
                                            $('.storedpayment-messagingSection-Info').css('display', 'none');
                                        }, 5000);
                                        UTIL.hideLoader();
                                        return;
                                    }
                                    //alert($('#cardNumber-container').val);
                                    isValidate= validateFields();                                
                                    if(!isValidate){
                                        UTIL.hideLoader();
                                        return;
                                    }
                                    var cardcheck = validateCard(cardType);
                                    if (!cardcheck){
                                        UTIL.hideLoader();
                                        return;
                                    }
                                    if(!isCardValid){
                                        let cardErrorMsg = '';
                                        if(cardError){
                                            cardErrorMsg = cardError;
                                        } else {
                                            cardErrorMsg = 'Please enter valid card number';
                                        }      
                                        addErrorMessage('ERROR', 'cc-messagingSection-Error', cardErrorMsg);
                                        UTIL.hideLoader(); 
                                        return;
                                    }

                                    //$(".processBack").prop('disabled', true);
                                    // Send in optional parameters from other parts of your payment form
                                    var options = {
                                        cardExpirationMonth: expMonth.value,
                                        cardExpirationYear: expYear.value,
                                        code:cvv.value,
                                        // cardType:cardType.value
                                    };
                                    if(isCardValid && cardcheck && isValidate && isCheck){
                                        microformInstance.createToken(options, function (err, response) {
                                            if (err) {  
                                                if(isCardValid){
                                                    addErrorMessage('ERROR', 'cc-messagingSection-Error', err.details.responseStatus.message); 
                                                } else {
                                                    UTIL.hideLoader();
                                                }      
                                                return;
                                            }                                                
                                            console.log('Token generated: ');
                                            // At this point the token may be added to the form
                                            // as hidden fields and the submission continued
                                            flexResponse.value = JSON.stringify(response);
                                            if(flexResponse.value !==null){
                                                $(".alert-danger").addClass("hidden");
                                                event.preventDefault();
                                                response['expMonth']=document.querySelector('#expMonth').value;
                                                response['expYear']=document.querySelector('#expYear').value;
                                                response['ccStreet']=document.getElementById('cardStreet').value,
                                                response['ccCity']=document.getElementById('cardCity').value,
                                                response['ccState']=document.getElementById('stateId').value,
                                                response['ccPostalCode']=document.getElementById('cardPostalCode').value,
                                                response['ccCountry']=document.getElementById('countryId').value,
                                                response['ccLastName']=document.getElementById('cardLastName').value,
                                                response['ccFirstName']=document.getElementById('cardFirstName').value,
                                                response['ccPo']= ''//document.getElementById('cardPo').value
                                                //setCartAdd(JSON.stringify(response));
                                                intilizeRemoting(JSON.stringify(response));                                       
                                            }                        
                                        });
                                    }
                                } else {
                                    _this.model.set('submitCounter', 0);
                                    UTIL.hideLoader();
                                    return;
                                }
                            });
                        }
                    );  
                }
            }       
            function remvError(ele1){
                $('.'+ele1).css('border-color','#3c763d');}
    
            function isNumberKey(evt) {
                var charCode = (evt.which) ? evt.which : event.keyCode;
                if (charCode > 31 && (charCode < 48 || charCode > 57)){
                    return false;
                }
                return true;
            }
        
            function validateFields(){
                $("#makePODPayment").attr("disabled", true);
                $("#overlayDivOne").css("display", "block");
                var firstName=document.getElementById("cardFirstName").value;
                var lastName=document.getElementById("cardLastName").value;
                var payType=document.getElementById("cardType").value;
                var cardNumb=document.getElementById("cardNumber-container").value;
                var expY=document.getElementById("expYear").value;
                var expM=document.getElementById("expMonth").value;
                var cvv=document.getElementById("cvv").value;          
                var cardStreet = document.getElementById("cardStreet").value;
                var cardCity = document.getElementById("cardCity").value;
                var cardPostalCode = document.getElementById("cardPostalCode").value;
                               
                var textVal = validateNameFields(firstName,lastName);
                if(textVal == 'success') {                        
                    if($(".creditMsg").hasClass("hidden")){
                        $('.creditMsg').addClass('hidden');
                    }                        
                } else {
                    return;
                }
                if(payType == ""){
                    addErrorMessage('ERROR', 'cc-messagingSection-Error', 'Please select a card type');
                    return ;
                }
                let currentYear = new Date().getFullYear(), currentMonth = new Date().getMonth() + 1;
                if($("#expMonth").val().length < 2 ||expM > 12 || expM < 1 || (currentYear == $("#expYear").val() && expM < currentMonth)){   
                    addErrorMessage('ERROR', 'cc-messagingSection-Error', 'Please enter valid expiration month XX');
                    return ;
                }
                if($("#expYear").val().length < 4 || currentYear > $("#expYear").val()){
                    addErrorMessage('ERROR', 'cc-messagingSection-Error', 'Please enter valid expiration year XXXX');
                    return ;
                }                    
                if(payType == '003'){
                    if($("#cvv").val().length !== 4){ 
                        addErrorMessage('ERROR', 'cc-messagingSection-Error', 'Four digit cvv are required for American Express');
                        return ;
                    }
                } else if($("#cvv").val().length !== 3){   
                    addErrorMessage('ERROR', 'cc-messagingSection-Error', 'Please enter valid cvv'); 
                    return ;
                }       
                
                if(cardStreet == ""){
                    addErrorMessage('ERROR', 'cc-messagingSection-Error', 'Please enter a Billing Street');
                    return ;
                }
                if(cardCity == ""){
                    addErrorMessage('ERROR', 'cc-messagingSection-Error', 'Please enter a Billing city');
                    return ;
                }
                if(cardPostalCode == ""){
                    addErrorMessage('ERROR', 'cc-messagingSection-Error', 'Please enter a postal code');
                    return ;
                }
                return true;    
            }
            validateNameFields = function(first,last) {
                //var firstName = document.getElementById("cardFirstName").value; //$("cardFirstName").val();
                //var lastName = document.getElementById("cardLastName").value; //$("cardLastName").val();
                var firstName = first;
                var lastName = last;
                var textMsg ='';
                if(firstName == '' || !firstName.match(/^[a-zA-Z\s]+$/)){
                    addErrorMessage('ERROR', 'cc-messagingSection-Error', 'First name accepts only characters');
                    return;               
                }
                else if( lastName == '' || !lastName.match(/^[a-zA-Z\s]+$/)){
                    addErrorMessage('ERROR', 'cc-messagingSection-Error', 'Last name accepts only characters');
                    return;                     
               }
               else {
                   textMsg ='success';
                   return textMsg;
               }
       
               //return textMsg;
            }
            function validateCard(type){
                var cardError;               
                var cardType=document.getElementById("cardType").value;
                var cardName;
                if(cardType == '001'){
                    cardName = 'Visa';
                }
                else if(cardType == '002'){
                    cardName = 'MasterCard';
                }
                else if(cardType == '003'){
                    cardName = 'American Express';
                }
                else if(cardType == '004'){
                    cardName = 'Discover';
                } else {
                    addErrorMessage('ERROR', 'cc-messagingSection-Error', 'Please select a card type');
                    return false;
                }                             
                if(cardName.toLowerCase() !== type.toLowerCase()){                               
                    cardError = 'Please enter valid card number for ' + cardName;
                    addErrorMessage('ERROR', 'cc-messagingSection-Error', cardError);
                    return false;
                } 
                return true;                                  
            }

            function addErrorMessage(type, container, message){
                CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage(type, container, message));
                $('html, body').animate({
                    'scrollTop' : $("." + container).position().top
                });
                UTIL.hideLoader();
                setTimeout(function(){
                    $("#makePODPayment").prop("disabled", false);
                }, 2000);  
                setTimeout(function(){
                    $("." + container).css("display", "none");
                }, 6000);  
            }
            
            function checkCreditCard (cardnumber, cardname) {
     
                // Array to hold the permitted card characteristics
                var cards = new Array();
              
                // Define the cards we support. You may add addtional card types as follows.
                
                //  Name:         As in the selection box of the form - must be same as user's
                //  Length:       List of possible valid lengths of the card number for the card
                //  prefixes:     List of possible prefixes for the card
                //  checkdigit:   Boolean to say whether there is a check digit
                
                cards [0] = {name: "Visa", 
                             length: "13,16", 
                             prefixes: "4",
                             checkdigit: true};
                cards [1] = {name: "MasterCard", 
                             length: "16", 
                             prefixes: "51,52,53,54,55",
                             checkdigit: true};
                cards [2] = {name: "DinersClub", 
                             length: "14,16", 
                             prefixes: "36,38,54,55",
                             checkdigit: true};
                cards [3] = {name: "CarteBlanche", 
                             length: "14", 
                             prefixes: "300,301,302,303,304,305",
                             checkdigit: true};
                cards [4] = {name: "American Express", 
                             length: "15", 
                             prefixes: "34,37",
                             checkdigit: true};
                cards [5] = {name: "Discover", 
                             length: "16", 
                             prefixes: "6011,622,64,65",
                             checkdigit: true};
                cards [6] = {name: "JCB", 
                             length: "16", 
                             prefixes: "35",
                             checkdigit: true};
                cards [7] = {name: "enRoute", 
                             length: "15", 
                             prefixes: "2014,2149",
                             checkdigit: true};
                cards [8] = {name: "Solo", 
                             length: "16,18,19", 
                             prefixes: "6334,6767",
                             checkdigit: true};
                cards [9] = {name: "Switch", 
                             length: "16,18,19", 
                             prefixes: "4903,4905,4911,4936,564182,633110,6333,6759",
                             checkdigit: true};
                cards [10] = {name: "Maestro", 
                             length: "12,13,14,15,16,18,19", 
                             prefixes: "5018,5020,5038,6304,6759,6761,6762,6763",
                             checkdigit: true};
                cards [11] = {name: "VisaElectron", 
                             length: "16", 
                             prefixes: "4026,417500,4508,4844,4913,4917",
                             checkdigit: true};
                cards [12] = {name: "LaserCard", 
                             length: "16,17,18,19", 
                             prefixes: "6304,6706,6771,6709",
                             checkdigit: true};
                             
                // Establish card type
                var cardType = -1;
                for (var i=0; i<cards.length; i++) {
              
                  // See if it is this card (ignoring the case of the string)
                  if (cardname.toLowerCase () == cards[i].name.toLowerCase()) {
                    cardType = i;
                    break;
                  }
                }
                
                // If card type not found, report an error
                if (cardType == -1) {
                   ccErrorNo = 0;
                   return false; 
                }
                 
                // Ensure that the user has provided a credit card number
                if (cardnumber.length == 0)  {
                   ccErrorNo = 1;
                   return false; 
                }
                  
                // Now remove any spaces from the credit card number
                cardnumber = cardnumber.replace (/\s/g, "");
                
                // Check that the number is numeric
                var cardNo = cardnumber
                var cardexp = /^[0-9]{13,19}$/;
                if (!cardexp.exec(cardNo))  {
                   ccErrorNo = 2;
                   return false; 
                }
                     
                // Now check the modulus 10 check digit - if required
                if (cards[cardType].checkdigit) {
                  var checksum = 0;                                  // running checksum total
                  var mychar = "";                                   // next char to process
                  var j = 1;                                         // takes value of 1 or 2
                
                  // Process each digit one by one starting at the right
                  var calc;
                  for (i = cardNo.length - 1; i >= 0; i--) {
                  
                    // Extract the next digit and multiply by 1 or 2 on alternative digits.
                    calc = Number(cardNo.charAt(i)) * j;
                  
                    // If the result is in two digits add 1 to the checksum total
                    if (calc > 9) {
                      checksum = checksum + 1;
                      calc = calc - 10;
                    }
                  
                    // Add the units element to the checksum total
                    checksum = checksum + calc;
                  
                    // Switch the value of j
                    if (j ==1) {j = 2} else {j = 1};
                  } 
                
                  // All done - if checksum is divisible by 10, it is a valid modulus 10.
                  // If not, report an error.
                  if (checksum % 10 != 0)  {
                   ccErrorNo = 3;
                   return false; 
                  }
                }  
                
                // Check it's not a spam number
                if (cardNo == '5490997771092064') { 
                  ccErrorNo = 5;
                  return false; 
                }
              
                // The following are the card-specific checks we undertake.
                var LengthValid = false;
                var PrefixValid = false; 
                var undefined; 
              
                // We use these for holding the valid lengths and prefixes of a card type
                var prefix = new Array ();
                var lengths = new Array ();
                  
                // Load an array with the valid prefixes for this card
                prefix = cards[cardType].prefixes.split(",");
                    
                // Now see if any of them match what we have in the card number
                for (i=0; i<prefix.length; i++) {
                  var exp = new RegExp ("^" + prefix[i]);
                  if (exp.test (cardNo)) PrefixValid = true;
                }
                    
                // If it isn't a valid prefix there's no point at looking at the length
                if (!PrefixValid) {
                   ccErrorNo = 3;
                   return false; 
                }
                  
                // See if the length is valid for this card
                lengths = cards[cardType].length.split(",");
                for (j=0; j<lengths.length; j++) {
                  if (cardNo.length == lengths[j]) LengthValid = true;
                }
                
                // See if all is OK by seeing if the length was valid. We only check the length if all else was 
                // hunky dory.
                if (!LengthValid) {
                   ccErrorNo = 4;
                   return false; 
                };   
                
                // The credit card is in the required format.
                return true;
            }
        
            function intilizeRemoting(resp){
                let _this = CCRZ.views.PaymentsPODView;
                var saveCard = document.getElementById("saveAsStoredPayment").checked;
                //var saveCard = false;
                //var poNumber = document.getElementById("purchaseOrderCs").value;
                var poNumber = '';
                var transactionID = '';
                if(saveCard){
                    
                }
                var remoteCall = _.extend(CCRZ.RemoteInvocation,{className:'KFB2B_PaymentController'});
                remoteCall.invokeCtx(
                    'getCallResult',CCRZ.pagevars.currentCartID,saveCard,resp,poNumber,
                    function(res, event) {
                        if(event.status){
                            console.table('Result: ' + JSON.stringify(res));
                            console.table('res.data: '+res.data);
                            if(res['success']===true){
                                if(!res.data.isSuccess){
                                    console.table('data error:::: '+res.data.message);
                                    if(CCRZ.pagevars.pageLabels.ORBCB2B_PaymentErr != undefined){
                                        addErrorMessage('ERROR', 'cc-messagingSection-Error', CCRZ.pagevars.pageLabels.ORBCB2B_PaymentErr);
                                    }else{
                                        addErrorMessage('ERROR', 'cc-messagingSection-Error', res.data.message);
                                    }
                                } else{
                                    try{
                                        $('.creditMsg').addClass('hidden');

                                        $.alert({
                                            title:window.Label.B2BCust_ThanksYou,
                                            content:window.Label.B2BCust_OrderSbtSuccess,                                               
                                        });
                                        res.data['txObject'].accountType='pod';
                                        res.data['txObject'].formData= resp;
                                        if(saveCard){
                                            res.data['txObject'].token =res.data['txObject'].token;
                                            
                                        } 
                                        setTimeout(function(){ CCRZ.pubSub.trigger('action:processPayment', res.data['txObject']); }, 3000);
                                        console.log('processing completed');
                                    } 
                                    catch(e){
                                        UTIL.hiddeLoader();
                                    } 
                                }
                            }
                            else {
                                addErrorMessage('ERROR', 'cc-messagingSection-Error', res.data.message);
                            }
                        }
                    },            
                    {buffer:true,escape:false,nmsp:false}
                ); 
            }  
        }
    }
});